 /********************************************************************
 *                                                                   *
 * arp.c	Arp packet test = ARP-QUERY                          *
 *                         implementare alcuni attacchi gi noti     *
 * Popis:       Program vytvori IP/ARP-QUERY packet podle zadanych   *
 *              parametru a vysle jej jako broadcast do lokalni site *
 *                                                                   *
 * Dne: 	8.4.2003  -  Jan Kubr prvni verze, pouze vysilani    *
 *                                                                   *
 * Greets 	lupsyn  http://www.mojodo.it                         *
 *                                                                   *
 *********************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <linux/sockios.h>
#include <linux/if_ether.h>
#include <linux/if_arp.h>
#include <errno.h>


struct arp_packet
{
        u_char Dst_e_hw[ETH_ALEN];
        u_char Src_e_hw[ETH_ALEN];
        u_short frame_type;
        u_short hw_type;
        u_short prot_type;
        u_char hw_addr_size;
        u_char prot_addr_size;
        u_short op;
        u_char Src_a_hw[ETH_ALEN];
        u_char Src_a_ip[4];
        u_char Dst_a_hw[ETH_ALEN];
        u_char Dst_a_ip[4];
};



void    SendArpPkt(char *dev, char *src_a_ip, char *dst_a_ip);
void 	usage();
int 	getdevindex(int sock, char *name);
int  	strip(unsigned char *dst, char *str);



void usage ()
{
	fprintf (stderr,        " * Usage   : <dev> <Op> <Sip> <Dip> *\n"
				" *                                                                  *\n"
				" *  <dev>  : Shuld We send the packet over something ? :D           *\n"
	                        " *  <Sip>  : Source ip  address for arp header                      *\n"
                                " *  <Dip>  : Dest   ip  address for arp header                      *\n"
				" *                                                                  *\n");
	exit(0);
}



main(int argc, char *argv[])
{
	if (argc<3) usage();
//	fprintf (stderr,"\nLet's go boy... :p\n\n");
	SendArpPkt(argv[1], argv[2],argv[3]);

}




int getdevindex(int sock, char *name)
{
        struct ifreq ifr;

        memset(&ifr, 0, sizeof(ifr));
        strncpy(ifr.ifr_name, name, sizeof(ifr.ifr_name));
	if(ioctl(sock, SIOCGIFINDEX, &ifr) == -1)
               	{ perror("I can't get device flags"); exit (1);}
        fprintf(stderr,"Get ethernet  flags....\n");
	return ifr.ifr_ifindex;

}



int strip(unsigned char *dst, char *str)
{
        if(sscanf(str,"%d.%d.%d.%d",&dst[0],&dst[1],&dst[2],&dst[3])==4)
               return 0;
        return -1;
}



void SendArpPkt(char *dev, char *src_a_ip, char *dst_a_ip)
{
	struct sockaddr_ll to;
	struct arp_packet pkt;
	int sock;
	u_char *ch;
	int i;
	struct ifreq ifra;

	if( (sock = socket(PF_PACKET,SOCK_RAW,htons(ETH_P_ALL))) == -1)  {perror("Can't create socket"); exit (1);}
	if( (to.sll_ifindex = getdevindex(sock, dev)) == -1)  {perror("Can't get interface"); exit (1);}

	strcpy(ifra.ifr_name, dev); /* assuming we want eth0 */

	if( (ioctl(sock, SIOCGIFHWADDR, &ifra)) == -1)  {perror("Can't get MAC Address");  exit (1);}/* retrieve MAC address */

/*
* at this point, the interface's HW address is in
* 6 bytes in ifr.ifr_hwaddr.sa_data. You can copy them
* out with memcpy() or something similar. You'll have to
* translate the bytes into a readable hex notation.

* this is done below with a %x format of printf, and a for loop to
* add the traditional colons in the appropriate places
*/

	ch = ifra.ifr_hwaddr.sa_data;

	//Eth header
	fprintf (stderr,"HW Address: ");

	for ( i = 0; i <= 5; i++ )
 	  {
	   pkt.Src_e_hw[i] = *ch;
	   pkt.Src_a_hw[i] = *ch;
	   printf( "%02hX", pkt.Src_e_hw[i]  );
	   if ( i != 5 )
	     printf( ":" );
	     else printf( "\n" );
	     ch++;
	 }

	pkt.frame_type = htons(ETH_P_ARP);
	fprintf (stderr,"Eth header is ready....\n");

	//arp
	pkt.hw_type = htons(ARPHRD_ETHER);
	pkt.prot_type = htons(ETH_P_IP);
	pkt.hw_addr_size = ETH_ALEN;
	pkt.prot_addr_size = 4;
	pkt.op=htons(1);
	fprintf(stderr,"Arp header is ready....\n");

	//data
	strip(pkt.Src_a_ip,src_a_ip);
	strip(pkt.Dst_a_ip,dst_a_ip);
	memset(pkt.Dst_a_hw,0xff,6);
	memset(pkt.Dst_e_hw,0xff,6);

	//write and send
	if(sendto(sock,&pkt,sizeof(pkt),0,(struct sockaddr*)&to,sizeof(to))<0) {perror("I can't send the packet"); exit (1);}
	fprintf (stderr,"The packet is send.\n");
}
